#include <qdialog.h>
#include <qstrlist.h>
#include <kapp.h>
#include "typelayout.h"
#include "tlform.h"
#include "settingsdlg.h"

settingsdlg::settingsdlg()  
: QDialog() {
    TLForm *ktlform= new TLForm("settingsdlg", "", this);
    ktl= ktlform->layout;
    ktl->addGroup("path", i18n("Words"), true);
    ktl->addLabel("label1", i18n("Path to Words DB:"));
    ktl->addLineEdit("le1", "/usr/local/lib/dsing/words.database", -1);
    ktl->addButton("browse", i18n("..."));
    ktl->newLine();
    ktl->addLabel("label2", i18n("Word Delimiter:"));
    ktl->addLineEdit("le2", "::", 9);
    ktl->skip();
    ktl->endGroup();
    ktl->newLine();
    ktl->addGroup("misc", i18n("Appearance"), true);
    ktl->newLine();
    ktl->addCheckBox("cb1", i18n("Clear list for new search"), true);
    ktl->setSpawn("cb1", 3, 1);
    ktl->newLine();
    ktl->addCheckBox("cb2", i18n("Show all"), true);
    ktl->skip();
    ktl->addLabel("label4", i18n("or show max. hits :"));
    ktl->addLineEdit("le3", "200", 7);
    ktl->endGroup();
    ktl->newLine();
    ktl->addGroup("searching", i18n("Searching"), true);
    ktl->newLine();
    ktl->addCheckBox("cb3", i18n("word search"), false);
    ktl->addCheckBox("cb6", i18n("use zgrep"), false);
    ktl->newLine();
    ktl->addCheckBox("cb4", i18n("case insensitive"), false);
    ktl->addCheckBox("cb7", i18n("show command"), false);
    ktl->newLine();
    ktl->addCheckBox("cb5", i18n("always at beginning of line"), false);
    ktl->addCheckBox("cb8", i18n("regular expressions"), false);
    ktl->endGroup();
    ktl->newLine();
    ktl->addGroup("leave", i18n(""), false);
    ktl->addButton("apply", i18n("Apply"));
    ktl->addButton("ok", i18n("OK"));
    ktl->addButton("cancel", i18n("Cancel"));
    ktl->endGroup();
    ktl->newLine();
    ktl->activate();
}
#include "settingsdlg.moc"
